//+------------------------------------------------------------------+
//|                                     WriteOptimizationResults.mq5 |
//|            Copyright 2013, https://login.mql5.com/ru/users/tol64 |
//|                                  Site, http://tol64.blogspot.com |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2013, http://tol64.blogspot.com"
#property link        "http://tol64.blogspot.com"
#property description "email: hello.tol64@gmail.com"
#property version     "1.0"
//---  
#define EXPERT_NAME MQL5InfoString(MQL5_PROGRAM_NAME)
//---     
#define COMMONDATA_PATH TerminalInfoString(TERMINAL_COMMONDATA_PATH)
//--- -     
#define STAT_VALUES_COUNT 7
//---  
#include <Trade/Trade.mqh>
//---  
CTrade              trade;
//---  
MqlTick             last_tick;
//---    
MqlTradeResult      trade_result;
//---   
MqlTradeRequest     trade_request;
//---     
MqlTradeCheckResult trade_check_result;
//---   
#include "Include/Enums.mqh"
#include "Include/Errors.mqh"
#include "Include/TradeSignals.mqh"
#include "Include/TradeFunctions.mqh"
#include "Include/FileFunctions.mqh"
#include "Include/Auxiliary.mqh"
//---   
input  int              NumberOfBars           = 2;              //   
sinput double           Lot                    = 0.1;            // 
input  double           TakeProfit             = 100;            //  
input  double           StopLoss               = 50;             //  
input  double           TrailingStop           = 10;             //  
input  bool             Reverse                = true;           //  
sinput string           delimeter=""; // --------------------------------
sinput bool             LogOptimizationReport  = true;           //    
sinput CRITERION_RULE   CriterionSelectionRule = RULE_AND;       //   
sinput ENUM_STATS       Criterion_01           = C_NO_CRITERION; // 01 -  
sinput double           CriterionValue_01      = 0;              // ----  
sinput ENUM_STATS       Criterion_02           = C_NO_CRITERION; // 02 -  
sinput double           CriterionValue_02      = 0;              // ----  
sinput ENUM_STATS       Criterion_03           = C_NO_CRITERION; // 03 -  
sinput double           CriterionValue_03      = 0;              // ----  
//---  
int    AllowedNumberOfBars=0;       //      NumberOfBars
string OptimizationResultsPath="";  //        
int    UsedCriteriaCount=0;         //   
int    OptimizationFileHandle=-1;   //      
//---
double close_price[]; // Close (  )
double open_price[];  // Open (  )
double high_price[];  // High (  )
double low_price[];   // Low (  )
//---
int    criteria[3];                    //     
double criteria_values[3];             //  
double stat_values[STAT_VALUES_COUNT]; //    
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   
   CheckNewBar();
//---   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---     
   Print(GetDeinitReasonText(reason));
//---     ()
   Print("TERMINAL_MEMORY_USED: ",TerminalInfoInteger(TERMINAL_MEMORY_USED)," Mb");
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void OnTick()
  {
//---    , 
   if(!CheckNewBar())
      return;
//---    
   else
     {
      GetBarsData();        //   
      TradingBlock();       //    
      ModifyTrailingStop(); //   Trailing Stop
     }
  }
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
void OnTesterInit()
  {
   Print(__FUNCTION__,"(): Start Optimization \n-----------");
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
double OnTester()
  {
//---     
   if(LogOptimizationReport)
     {
      //---    
      GetTestStatistics(stat_values);
      //---  
      FrameAdd("Statistics",1,0,stat_values);
     }
//---
   return(0.0);
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void OnTesterPass()
  {
//---     
   if(LogOptimizationReport)
      CreateOptimizationReport();
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
void OnTesterDeinit()
  {
   Print("-----------\n",__FUNCTION__,"(): End Optimization");
//---     
   if(LogOptimizationReport)
     {
      //---    
      FileClose(OptimizationFileHandle);
     }
  }
//+------------------------------------------------------------------+
